% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/functions-xcmsSet.R
\name{phenoDataFromPaths}
\alias{phenoDataFromPaths}
\title{Derive experimental design from file paths}
\usage{
phenoDataFromPaths(paths)
}
\arguments{
\item{paths}{\code{character} representing the file names (including the full
path) of the experiment's files.}
}
\description{
The \code{phenoDataFromPaths} function builds a \code{data.frame}
representing the experimental design from the folder structure in which
the files of the experiment are located.
}
\note{
This function is used by the \emph{old} \code{xcmsSet} function to guess
the experimental design (i.e. group assignment of the files) from the
folders in which the files of the experiment can be found.
}
\examples{
## List the files available in the faahKO package
base_dir <- system.file("cdf", package = "faahKO")
cdf_files <- list.files(base_dir, recursive = TRUE, full.names = TRUE)
}
